/*
	AI Landing by Heli - by Enigx
	
	AILandingByHeli_V2.sqf
		  
*/

_tranType = _this select 0;
_HeliWypArray = _this select 1;
_HeliEscapeWypArray = _this select 2;
_sideFact = _this select 3;
_unitArray = _this select 4;
_UnitWypArray = _this select 5;

private ["_heightLnd","_nAI","_nWypHeli","_nWypUnits","_landPosHeli","_EndHeliTr","_helicopterTr","_grpHeliPilots","_grpAIUn","_helicopterTrGrp"];

_heightLnd = 100; 

_nAI = count _unitArray;
_nWypHeli = (count _HeliWypArray) - 1;
_nWypUnits = (count _UnitWypArray) - 1;

_landPosHeli = createVehicle ["Land_HelipadEmpty_F", getMarkerPos (_HeliWypArray # _nWypHeli)];		
		
if (_HeliEscapeWypArray # 0 == 0) then {
	_obj1 = createVehicle ["Land_PenBlack_F",[getMarkerPos (_HeliEscapeWypArray # 1) # 0,getMarkerPos (_HeliEscapeWypArray # 1) select 1,_heightLnd]];
	_obj2 = createVehicle ["Land_PenBlack_F",[getMarkerPos (_HeliWypArray # _nWypHeli) select 0,getMarkerPos (_HeliWypArray # _nWypHeli) select 1,_heightLnd]];
	_grDir = _obj2 getDir _obj1;
	createMarkerLocal ["EndHeliTr",_obj1 getRelPos [3000, _grDir]];
	_EndHeliTr = getMarkerPos "EndHeliTr";			
	deleteVehicle _obj1;
	deleteVehicle _obj2;
	deleteMarkerLocal "EndHeliTr";
};

_objPos = createVehicle ["Land_PenBlack_F",getMarkerPos (_HeliWypArray # 0)];
_objDir = createVehicle ["Land_PenBlack_F",getMarkerPos (_HeliWypArray # 1)];
_gradiDir = _objPos getDir _objDir;
deleteVehicle _objPos;
deleteVehicle _objDir;

_helicopterTr = createVehicle [_tranType, [getMarkerPos (_HeliWypArray # 0) select 0,getMarkerPos (_HeliWypArray # 0) select 1,_heightLnd],[], 0,"FLY"];
_helicopterTr flyInheight _heightLnd; // imposto la quota di volo per il velivolo
_helicopterTr setDir _gradiDir;
//_helicopterTr allowDamage false;
_grpHeliPilots = createGroup [_sideFact, true];
_HeliPilot = _grpHeliPilots createUnit [_unitArray # 0, getMarkerPos (_HeliWypArray select 0), [], 0, "FORM"];
[_HeliPilot] join _grpHeliPilots;
_HeliPilot assignAsDriver _helicopterTr; _HeliPilot moveInDriver _helicopterTr;
_HeliPilot setSkill 1;

_crewCount = [_tranType, true] call BIS_fnc_crewCount;
_cargoCount = _crewCount - 1;
if (_nAI > _cargoCount) then {_nAI = _cargoCount-1};		
_grpAIUn = createGroup [_sideFact, true];
for "_i" from 0 to (_nAI-1) do {			
	_cUnit = _grpAIUn createUnit [_unitArray # _i, getMarkerPos (_HeliWypArray # 0), [], 0, "FORM"];				
	[_cUnit] join _grpAIUn;
	_cUnit moveincargo _helicopterTr;
};

_helicopterTrGrp = group _helicopterTr;
for "_j" from 1 to (_nWypHeli-1) do {
	_wp = _helicopterTrGrp addWaypoint [[getMarkerPos (_HeliWypArray # _j) select 0, getMarkerPos (_HeliWypArray # _j) select 1,_heightLnd], 0];
	_wp setWaypointType "MOVE";
	_wp setWaypointBehaviour "CARELESS";
	_wp setWaypointCombatMode "GREEN";
	_wp setWaypointSpeed "NORMAL";
};

_wpLand = _helicopterTrGrp addWaypoint [[getMarkerPos (_HeliWypArray # _nWypHeli) select 0, getMarkerPos (_HeliWypArray # _nWypHeli) select 1,_heightLnd], 0];
_wpLand setWaypointType "MOVE";
_wpLand setWaypointBehaviour "CARELESS";
_wpLand setWaypointCombatMode "GREEN";
//_wpLand setWaypointSpeed "NORMAL";
_wpLand setWaypointStatements ["true", "(vehicle this) land 'GET OUT'"];	
			
waitUntil {(getPosATL _helicopterTr) select 2 < 20};
waitUntil {(getPosATL _helicopterTr) select 2 < 1};
{unassignVehicle _x} forEach units _grpAIUn;
		
for "_k" from 0 to _nWypUnits do {
	_wpUn = _grpAIUn addWaypoint [getMarkerPos (_UnitWypArray # _k), 0];
	_wpUn setWaypointType "MOVE";
	_wpUn setWaypointBehaviour "AWARE";
	_wpUn setWaypointCombatMode "YELLOW";
	_wpUn setWaypointSpeed "NORMAL";
	_wpUn setWaypointFormation "WEDGE";			
};

sleep 15;
	
if (_HeliEscapeWypArray # 0 == 0) then {
	_helicopterTr flyinheight _heightLnd;					
	_wpEscape = _helicopterTrGrp addWaypoint [[getMarkerPos (_HeliEscapeWypArray # 1) select 0, getMarkerPos (_HeliEscapeWypArray # 1) select 1,_heightLnd], 0];		
	_wpEscape setWaypointType "MOVE";
	_wpEscape setWaypointBehaviour "CARELESS";
	_wpEscape setWaypointCombatMode "GREEN";
	_wpEscape setWaypointSpeed "NORMAL";
	
	_wpDel = _helicopterTrGrp addWaypoint [[_EndHeliTr select 0,_EndHeliTr select 1,_heightLnd], 0];
	_wpDel setWaypointType "MOVE";
	_wpDel setWaypointBehaviour "CARELESS";
	_wpDel setWaypointCombatMode "GREEN";
	_wpDel setWaypointSpeed "NORMAL";
	_wpDel setWaypointStatements ["true", "trasp_hel = vehicle leader this; { deleteVehicle _x } forEach crew trasp_hel + [trasp_hel]"];
} else {
	_helicopterTr engineOn false;
};

deleteVehicle _landPosHeli;                            